package com.engine.organization.entity.department.dto;

import com.cloudstore.eccom.pc.table.WeaTableType;
import com.engine.organization.annotation.OrganizationTable;
import com.engine.organization.annotation.TableTitle;
import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.apache.commons.collections.CollectionUtils;

import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @Author weaver_cl
 * @description:
 * @Date 2022/5/19
 * @Version V1.0
 **/
@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
@OrganizationTable(pageId = "96f2bb0d-da73-11ec-a0da-00ffcbed7508",
        tableType = WeaTableType.NONE)
public class DepartmentListDTO {

    private Integer id;
    /**
     * 是否被引用
     */
    private Integer isUsed;

    /**
     * 名称
     */
    @TableTitle(labelId = 547181, title = "简称", dataIndex = "departmentMark", key = "departmentMark", width = "200")
    private String departmentMark;

    /**
     * 编号
     */
    @TableTitle(labelId = 547118, title = "编号", dataIndex = "departmentCode", key = "departmentCode")
    private String departmentCode;

    /**
     * 简称
     */
    @TableTitle(labelId = 547141, title = "名称", dataIndex = "departmentName", key = "departmentName")
    private String departmentName;

    /**
     * 所属分部
     */
    @TableTitle(labelId = 547128, title = "所属分部", dataIndex = "subCompanyName", key = "subCompanyName")
    private String subCompanyName;
    private Integer subCompanyId1;

    /**
     * 上级部门
     */
    @TableTitle(labelId = 547189, title = "上级部门", dataIndex = "supDepName", key = "supDepName")
    private String supDepName;

    private Integer supDepId;

    /**
     * 部门负责人
     */
    @TableTitle(labelId = 547190, title = "部门负责人", dataIndex = "bmfzr", key = "bmfzr")
    private String bmfzr;

    /**
     * 显示顺序
     */
    @TableTitle(labelId = 547185, title = "显示顺序", dataIndex = "showOrder", key = "showOrder", sorter = true)
    private Double showOrder;


    /**
     * 禁用标记
     */
    @TableTitle(labelId = 547186, title = "启用", dataIndex = "canceled", key = "canceled")
    private int canceled;

    /**
     * 附件上传
     */
    @TableTitle(labelId = 17616, title = "附件上传", dataIndex = "imageFileName", key = "imageFileName")
    private String imageFileName;

    private String imageFileId;


    /**
     * 操作列
     */
    @TableTitle(title = "", dataIndex = "operate", key = "operate")
    private String operate;
    /**
     * 子节点
     */
    private List<DepartmentListDTO> children;

    private String orderType;

    public Double getShowOrder() {
        return null == showOrder ? 0 : showOrder;
    }

    public List<DepartmentListDTO> getChildren() {
        if (CollectionUtils.isEmpty(children)) {
            return children;
        }
        if ("asc".equalsIgnoreCase(orderType)) {
            return children.stream().sorted(Comparator.comparingDouble(DepartmentListDTO::getShowOrder)).collect(Collectors.toList());
        } else {
            return children.stream().sorted(Comparator.comparingDouble(DepartmentListDTO::getShowOrder).reversed()).collect(Collectors.toList());
        }
    }
}
